/* \file objects.h
 * \brief: prototype header for all objects.
 */

#ifndef ALL_OBJECTS_H_
#define ALL_OBJECTS_H_

class Object;
class Matice;
class Matpar;
class Node;
class Penta;
class Tria;
class Sing;
class Beam;
class Spc;
class Rgb;
class Icefront;
class Riftfront;
class Penpair;
class Pengrid;
class Numericalflux;
class Param;
class Element;
class NodeSets;
class Model;
class TriaVertexInput;
class DoubleInput;
class IntInput;
class BoolInput;
class Input;

/*Abstract class: */
#include "./Object.h"

/*C++ Objects: */
#include "./Material.h"
#include "./Matice.h"
#include "./Matpar.h"
#include "./Node.h"
#include "./Penta.h"
#include "./Tria.h"
#include "./Sing.h"
#include "./Beam.h"
#include "./Spc.h"
#include "./Result.h"
#include "./Rgb.h"
#include "./Icefront.h"
#include "./Riftfront.h"
#include "./Penpair.h"
#include "./Pengrid.h"
#include "./Numericalflux.h"
#include "./Param.h"
#include "./Element.h" 
#include "./NodeSets.h"
#include "./Model.h"
#include "./Input.h"
#include "./TriaVertexInput.h"
#include "./BoolInput.h"
#include "./IntInput.h"
#include "./DoubleInput.h"

/*C objects: */
#include "./Contour.h"
#include "./Friction.h"
#include "./SolverEnum.h"
#include "./FemModel.h"
#include "./OptArgs.h"
#include "./OptPars.h"
#include "./BamgGeom.h"
#include "./BamgMesh.h"
#include "./BamgOpts.h"

#endif
